/***************************************
*
*     PROJECT: XbpCheckColumn
*        FILE: CheckCol.prg
*  Programmer: J.A. Diego Kerejeta
*     Created: 15/12/2005
*  
****************************************/

#include "Appevent.ch"
#include "Common.ch"
#include "Font.ch"
#include "Gra.ch"
#include "Xbp.ch"

#pragma Library( "XppUi2.lib" )

# define CHECK_ON_MARK   '.'
# define CHECK_OFF_MARK  ':'

#xtrans  PRESPARAM_TEST   => {;
         { XBP_PP_COL_DA_FGCLR            , GRA_CLR_BLACK                        }, ;
         { XBP_PP_COL_DA_BGCLR            , GRA_CLR_WHITE                        }, ;
         { XBP_PP_COL_DA_COMPOUNDNAME     , '8.Arial'                            }, ;
         { XBP_PP_COL_DA_ROWSEPARATOR     , XBPLINE_NONE                         }, ;
         { XBP_PP_COL_DA_COLSEPARATOR     , XBPLINE_NONE                         }, ;
         { XBP_PP_COL_DA_FRAMELAYOUT      , XBPFRAME_NONE                        }, ;
         { XBP_PP_COL_DA_CELLFRAMELAYOUT  , XBPFRAME_BOX + XBPFRAME_RAISED       }, ;
         { XBP_PP_COL_DA_HILITEFRAMELAYOUT, XBPFRAME_NONE                        } }


****************
PROCEDURE AppSys
****************
RETURN


**************
PROCEDURE Main
**************
LOCAL oXbp, mp1, mp2, nEvent, oDlg, nCont, oBrowse, nCol
LOCAL aSizeDesk := AppDesktop():currentSize()
LOCAL aSize     := { 470, 550 }
LOCAL aPos      := { INT( ( aSizeDesk[ 1 ] - aSize[ 1 ] ) / 2 ), ;
                     INT( ( aSizeDesk[ 2 ] - aSize[ 2 ] ) / 2 ) }
LOCAL aStruct   := { { 'CAMPO_111', 'C', 25, 0  }, ;
                     { 'CAMPO_222', 'N',  6, 0  }, ;
                     { 'CAMPO_333', 'C', 25, 0  }, ;
                     { 'CAMPO_444', 'N',  6, 0  }, ;
                     { 'F_CHECK',   'L',  1, 0  } }


IF ! File( 'KK.DBF' )
   DBcreate( 'KK', aStruct )

   USE KK NEW EXCLUSIVE

   FOR nCont:= 1 TO 80
       KK->( DBappend() )
       KK->CAMPO_111:= CMONTH( DATE() + 31 * nCont )
       KK->CAMPO_222:= nCont + 1000
       KK->CAMPO_333:= CMONTH( DATE() + 31 * ( 37 - nCont ) )
       KK->CAMPO_444:= 37 - nCont + 1000
   NEXT
   KK->( DBgoTop() )
ELSE
   USE KK NEW EXCLUSIVE
ENDIF

oDlg := XbpDialog():new(,, aPos, aSize,, .F. )
   oDlg:title    := 'Test'
   oDlg:drawingArea:ClipChildren := .F.
   oDlg:create()
   oDlg:drawingArea:setFontCompoundName( FONT_DEFPROP_SMALL )

   oBrowse:= Browse( oDlg:drawingArea, aStruct )

   oDlg:drawingArea:resize := {|mp1,mp2,obj| obj:childList()[1]:setSize(mp2) }

   oDlg:show()
   oBrowse:show()

   SetAppWindow( oDlg )
   SetAppFocus( oBrowse )

   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
   QUIT
RETURN

***********************************
FUNCTION Browse( oParent, aStruct )
***********************************
LOCAL aPP, oBrowse, oColumn

oBrowse := XbpBrowse():new( oParent,, { 0, 0 }, , PRESPARAM_TEST, .F. )
   oBrowse:skipBlock     := {|n| DbSkipper(n) }
   oBrowse:goTopBlock    := {| | DbGoTop()    }
   oBrowse:goBottomBlock := {| | DbGoBottom() }
   oBrowse:phyPosBlock   := {| | Recno()      }
   oBrowse:posBlock      := {| | DbPosition()    }
   oBrowse:goPosBlock    := {|n| DbGoPosition(n) } 
   oBrowse:lastPosBlock  := {| | 100             }
   oBrowse:firstPosBlock := {| | 0               }
   oBrowse:cursorMode    := XBPBRW_CURSOR_ROW
   oBrowse:create()

aPP := { { XBP_PP_COL_HA_CAPTION, aStruct[ 1, 1 ] } }

oColumn := XbpCheckColumn():new( oBrowse,,,, aPP )
   oColumn:dataLink      := {|x| IIF( KK->F_CHECK, CHECK_ON_MARK, CHECK_OFF_MARK ) + '       ' + KK->CAMPO_111 }
   oColumn:dataLinkCheck := {|x| KK->F_CHECK:= x }
   oBrowse:addColumn( oColumn )

aPP[ 1, 2 ] := aStruct[ 2 , 1 ]

oColumn := XbpColumn():new( oBrowse,,,, aPP )
   oColumn:dataLink := {|x| KK->CAMPO_222 }
   oBrowse:addColumn( oColumn )

aPP[ 1, 2 ] := aStruct[ 3 , 1 ]

oColumn := XbpColumn():new( oBrowse,,,, aPP )
   oColumn:dataLink := {|x| KK->CAMPO_333 }
   oBrowse:addColumn( oColumn )

aPP[ 1, 2 ] := aStruct[ 4 , 1 ]

oColumn := XbpColumn():new( oBrowse,,,, aPP )
   oColumn:dataLink := {|x| KK->CAMPO_444 }
   oBrowse:addColumn( oColumn )

RETURN oBrowse


************************************
************************************

CLASS XbpCheckColumn FROM XbpColumn

************************************
************************************
EXPORTED:
   VAR DatalinkCheck

   INLINE METHOD create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ********************************************************************
       ::dataArea:= XbpCheckCellGroup():new( self )
       ::dataArea:datalinkCheck:= ::datalinkCheck
   RETURN ::XbpColumn:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   INLINE METHOD RefreshRows( nFirtsRow, nLastRow )
   ************************************************
       ::dataArea:lEraseChecks:= .T.
       ::XbpColumn:refreshRows( nFirtsRow, nLastRow )
   RETURN self
ENDCLASS

*****************************************

CLASS XbpCheckCellGroup FROM XbpCellGroup

*****************************************
PROTECTED:
   VAR nRowsCount
   VAR aoChecks

EXPORTED:
   VAR lEraseChecks
   VAR DatalinkCheck

   INLINE METHOD init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *****************************************************************
      ::XbpCellGroup:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
      ::ClipChildren  := .T.
      ::lEraseChecks  := .F.
   RETURN self

   INLINE METHOD destroy
   *********************
      ::XbpCellGroup:destroy()
      ::aoChecks:= nil
   RETURN self

   INLINE METHOD setSize( aSize, lRepaint )
   ****************************************
      LOCAL nRowsOld := ::rowCount()
      LOCAL nYsize   := ::currentSize()[ 2 ]
      LOCAL lSuccess := ::XbpCellGroup:setSize( aSize, lRepaint )

      ::nRowsCount:= ::rowCount()

      IF ::aoChecks = nil
         ::aoChecks:= ARRAY( ::nRowsCount )
         ::creaChecks( 1, ::nRowsCount )
      ELSEIF ::nRowsCount > nRowsOld
         ::SetPosChecks( 1, nRowsOld )
         ASIZE( ::aoChecks, ::nRowsCount )
         ::creaChecks( nRowsOld + 1, ::nRowsCount )
      ELSEIF ::nRowsCount < nRowsOld
         AEVAL( ::aoChecks, {|oCh| oCh:destroy() }, ::nRowsCount + 1 )
         ASIZE( ::aoChecks, ::nRowsCount )
         ::SetPosChecks( 1, ::nRowsCount )
      ELSEIF aSize[ 2 ] <> nYsize
         ::SetPosChecks( 1, ::nRowsCount )
      ENDIF
   RETURN lSuccess

   INLINE METHOD CreaChecks( nPosIni, nPosFin )
   ********************************************
      LOCAL aPos  := ::cellRect( nPosIni, .T. )
      LOCAL nSize := aPos[ 4 ] - aPos[ 2 ]
      LOCAL aSize := { nSize, nSize }
      LOCAL nCont, oIco

      FOR nCont:= nPosIni TO nPosFin
         oIco:= XbpCheckBox():New( self,, ::cellRect( nCont, .T. ), aSize )
            oIco:lbDown    := {|a,b,obj| ::_DownCheck( obj ) }
            oIco:create()

         ::aoChecks[ nCont ]:= oIco
      NEXT
   RETURN

   INLINE METHOD _DownCheck( oCheck )
   **********************************
      LOCAL oBro:= oCheck:setParent():setParent():setParent():setParent():setParent()

      oBro:navigate( XBPBRW_Navigate_Skip, oCheck:setParent():cellFromPos( oCheck:currentPos() ) - oBro:rowPos )
      ForceReadEvents()
      IF ::datalinkCheck <> nil
          EVAL( ::datalinkCheck, ! oCheck:editBuffer() )
      ENDIF
   RETURN self

   INLINE METHOD SetPosChecks( nPosIni, nPosFin )
   **********************************************
      LOCAL nCont

      FOR nCont:= nPosIni TO nPosFin
         ::aoChecks[ nCont ]:setPos( ::cellRect( nCont, .T. ) )
      NEXT
   RETURN 

   INLINE METHOD drawCell( xRowPos, lRepaint )
   ********************************************
      LOCAL lSuccess:= ::XbpCellGroup:drawCell( xRowPos, lRepaint )
      LOCAL nFin    := LEN( xRowPos )
      LOCAL xDato, nCont

      FOR nCont:= 1 TO nFin
         IF xRowPos[ nCont ] <> nil .AND. ( xDato:= ::getCell( xRowPos[ nCont ] ) ) <> nil
            ::aoChecks[ xRowPos[ nCont ] ]:setData( xDato[ 1 ] = CHECK_ON_MARK )
            IF ! ::aoChecks[ nCont ]:isVisible()
               ::aoChecks[ nCont ]:show()
            ENDIF
         ENDIF
       NEXT
       IF ::lEraseChecks
          ::lEraseChecks:= .F.
          FOR nCont:= ::nRowsCount TO 1 STEP -1
             IF ::getCell( nCont ) = nil
                ::aoChecks[ nCont ]:hide()
             ELSE
                EXIT
             ENDIF
          NEXT
       ENDIF
   RETURN lSuccess

   INLINE METHOD ScrollDown( nRows, lPaint )
   *****************************************
       LOCAL nScrolled:= ::XbpCellGroup:ScrollDown( nRows, lPaint )
       LOCAL nCont, xDato

       FOR nCont:= 1 TO ::nRowsCount
          IF ( xDato:= ::getCell( nCont ) ) = nil
             ::aoChecks[ nCont ]:hide()
          ELSE
             ::aoChecks[ nCont ]:setData( xDato[ 1 ] = CHECK_ON_MARK )
             IF ! ::aoChecks[ nCont ]:isVisible()
                ::aoChecks[ nCont ]:show()
             ENDIF
          ENDIF
       NEXT
   RETURN nScrolled

   INLINE METHOD ScrollUp( nRows, lPaint )
   ***************************************
       LOCAL nScrolled:= ::XbpCellGroup:ScrollUp( nRows, lPaint )
       LOCAL nCont, xDato

       FOR nCont:= 1 TO ::nRowsCount
          IF ( xDato:= ::getCell( nCont ) ) = nil
             ::aoChecks[ nCont ]:hide()
          ELSE
             ::aoChecks[ nCont ]:setData( xDato[ 1 ] = CHECK_ON_MARK )
             IF ! ::aoChecks[ nCont ]:isVisible()
                ::aoChecks[ nCont ]:show()
             ENDIF
          ENDIF
       NEXT
   RETURN nScrolled
ENDCLASS


*************************
PROCEDURE ForceReadEvents
*************************
LOCAL nEvent, oXbp, mp1, mp2

DO WHILE NextAppEvent() <> xbe_None
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
ENDDO
RETURN

*************************************
FUNCTION CenterPos( aSize, aRefSize )
*************************************
RETURN { Int( ( aRefSize[ 1 ] - aSize[ 1 ] ) / 2 ), ;
         Int( ( aRefSize[ 2 ] - aSize[ 2 ] ) / 2 ) }